function GTFW_PARSE(class_Wep)
{
	t <- {}
	t.tf_class <- 0;
	
	if ( "tf_class" in class_Wep )
		t.tf_class <- class_Wep.tf_class;
	else
		t.tf_class <- 0;
	
	if ( "func" in class_Wep )
		t.func <- class_Wep.func;
	else t.func <- null;

	if ( "worldModel" in class_Wep && "viewModel" in class_Wep ) {
		t.worldModel <- class_Wep.worldModel;
		t.viewModel <- class_Wep.viewModel;
	}
	else if ( "worldModel" in class_Wep && !("viewModel" in class_Wep) ) {
		t.worldModel <- class_Wep.worldModel;
		t.viewModel <- class_Wep.worldModel;
	}
	else if ( "viewModel" in class_Wep && !("worldModel" in class_Wep) ) {
		t.worldModel <- class_Wep.viewModel;
		t.viewModel <- class_Wep.viewModel;
	}

	if ( "classarms" in class_Wep )
		t.classarms <- class_Wep.classArms;
	else
		t.classarms <- "";

	
	t.name	<- class_Wep.name;
	if ( "nickname" in class_Wep )
		t.nickname	<- class_Wep.nickname;
	else
		t.nickname <- "";
	
	t.slot		<- class_Wep.slot;
	t.classname	<- class_Wep.classname;
	t.itemID	<- class_Wep.itemID;
	t.ammoType	<- class_Wep.ammoType;
	
	
	t.clipSize	<- class_Wep.clipSize;

	if ( "clipSizeMax" in class_Wep )
		t.clipSizeMax	<- class_Wep.clipSizeMax;
	else
		t.clipSizeMax	<- class_Wep.clipSize;
	
	t.reserve	<- class_Wep.reserve;
	
	if ( "reserveMax" in class_Wep )
		t.reserveMax <- class_Wep.reserveMax;
	else
		t.reserveMax	<- class_Wep.reserve;
	
	t.wearable	<- class_Wep.wearable;
	
	if ( "wearable_vm" in class_Wep )
		t.wearable_vm	<- class_Wep.wearable_vm;
	else
		t.wearable_vm	<- "";
	
	// gw_props stands for GiveWeapon PROPertieS
	// It's a bitmask that gives extra customization for weapons
	// i.e. if the weapon replaces the old one in slot, if it auto switches when obtained, if the weapon is announced in chat, etc.
	// "Defaults" is defined in `_master.nut`
	
	if ( "gw_props" in class_Wep )
		t.gw_props <- Defaults|class_Wep.gw_props;
	else
		t.gw_props <- Defaults;
	
	//AnnounceToChat bitmask
	 // item quality; color
	if ( "announce_quality" in class_Wep )
		t.announce_quality <- class_Wep.announce_quality;
	else
		t.announce_quality <- null;
	 // item prefix; i.e. "Unusual", "Haunted", "Collector's", etc.
	if ( "announce_prefix" in class_Wep )
		t.announce_prefix <- class_Wep.announce_prefix;
	else
		t.announce_prefix <- null;
	 // item "has found:" string
	if ( "announce_has_string" in class_Wep )
		t.announce_has_string <- class_Wep.announce_has_string;
	else
		t.announce_has_string <- null;


	// Post Wep Fix, for changing any other attributes
	if ( "PostWepFix" in class_Wep )
		t.postwepfix <- class_Wep.PostWepFix;
	else
		t.postwepfix <- null;
	
	// Finalize
	//local baseitem	= TF_WEAPONS_BASE(tf_class, slot, classname, itemID, itemName, ammoType, clipSize, clipSizeMax, reserve, reserveMax, worldModel, viewModel, wearable, wearable_vm, gw_props, func, classarms, postwepfix, announce_quality, announce_prefix, announce_has_string)
	
	return t
}


::GTFW_WEAPONS_BANK <- {};
::GTFW_WEAPONS_CUSTOM_BANK <- {};

foreach (preset in TF_WEAPONS_ALL)
{
	local wepTable = GTFW_PARSE(preset);
	GTFW_WEAPONS_BANK[wepTable.itemID] <- wepTable;
	printl("parsed "+ wepTable.name)
}
delete TF_WEAPONS_ALL;

foreach (preset in TF_WEAPONS_ALL_WARPAINTSnBOTKILLERS)
{
	local name = preset.name;
	local wepdata;
	foreach (k, t in GTFW_WEAPONS_BANK) {
		if ( t.name != name ) continue
		wepdata = t;
		break;
	}
	
	array <- [];
		
	array.append(preset.itemID);
	array.append(preset.itemID2);
	array.append(preset.itemID3);
	array.append(preset.itemID4);
	array.append(preset.itemID5);
	array.append(preset.itemID6);
	array.append(preset.itemID7);
	array.append(preset.itemID8);
	array.append(preset.itemID9);
	array.append(preset.itemID10);
	array.append(preset.itemID11);
	array.append(preset.itemID12);
	array.append(preset.itemID13);
	array.append(preset.itemID14);
	array.append(preset.itemID15);
	
	printl("parsing reskins of "+ name +"\t")
	foreach (k, ID in array) {
		if ( ID == null ) continue
		wepdata.itemID <- ID;
		GTFW_WEAPONS_BANK[ID] <- wepdata;
		print(ID+", ")
	}
	printl("")
}
delete TF_WEAPONS_ALL_WARPAINTSnBOTKILLERS;

return;